$(document).ready(function() {

	// Upload new custom file
	$('#uploadFile').click(function() {
		var fileDesc = $('#fileDesc');
		var theFile = $('#theFile');
		var uploaderInputs = $('#uploaderInputs');
		var uploaderLoader = $('#uploaderLoader');
		var uploaderStatus = $('#uploaderStatus');
		var noFiles = $('#noFiles');

		uploaderInputs.css('display', 'none');
		uploaderLoader.css('display', '');
		uploaderStatus.css('display', 'none');

		if(fileDesc.val() && theFile.val())
		{
			$.ajaxFileUpload({
				url: ateLang['U_ACTION_CLEAN'] + '&operation=upload_file&file_desc=' + fileDesc.val(),
				secureuri: false,
				fileElementId: 'theFile',
				dataType: 'json',
				success: function (data, status)
				{
					fileDesc.attr('value', ateLang['FILE_DESC']);

					uploaderStatus.css('display', '');
					uploaderInputs.css('display', '');
					uploaderLoader.css('display', 'none');

					if(data.msg.indexOf('UPLOADED') >= 0)
					{
						uploaderStatus.css('color', '#009600').html(ateLang['UPLOADED_SUCCESSFULLY']);

						ateTab(ateLang['S_FILES_TAB']);

						if(noFiles.length)
						{
							noFiles.slideUp('slow', insertFileRow(data.file_id, data.file_name, data.file_desc, data.file_size));
						}
						else
						{
							insertFileRow(data.file_id, data.file_name, data.file_desc, data.file_size);
						}

						$('#customFile' + data.file_id).slideDown('slow');
					}
					else
					{
						uploaderStatus.css('color', '#b90000').html(ateLang[data.msg]);
					}


				},
				error: function (data, status, e)
				{
					uploaderInputs.css('display', '');
					uploaderLoader.css('display', 'none');
					uploaderStatus.css({
						display: '',
						color: '#b90000'
					}).html(e);
				}
			});
		}
		else
		{
			uploaderInputs.css('display', '');
			uploaderLoader.css('display', 'none');
			uploaderStatus.css({
				display: '',
				color: '#b90000'
			}).html(ateLang[((fileDesc.val() == '') ? 'NO_FILE_DESC' : 'NO_FILE_SUBMITED')]);
		}                                                                                     
	});

	// Add element row to custom section
	$('#addElementRow').click(function() {

		var noElements = $('#noElements');
		var elementId = insertElementRow();

		if(noElements.length)
		{
			noElements.slideUp('slow', function() {
				$(this).remove();
				$('#elementId' + elementId).slideDown('slow');
			});
		}
		else
		{
			$('#elementId' + elementId).slideDown('slow');
		}
	});

	$('#ateSave').click(function() {

		$(this).css('display', 'none');
		$('#ateSaveBox').append('<div style="text-align: center;"><img src="./../ate_files/ajax_loader3.gif" alt="' + ateLang['SUBMITING_PLEASE_WAIT'] + '" /> ' + ateLang['SUBMITING_PLEASE_WAIT'] + '</div>');

		setTimeout("$('#acp_template').submit()", 1000);
	});
});

function removeVisualChanges()
{
	$('#visualChanges').css({
		display: 'none'
	});
}

function insertVisualChanges(id)
{
	if($('#visualChanges').length <= 0)
	{
		// show value
		$('body').append('<div id="visualChanges"><div id="visualChangesValue"></div></div>');
	}

	var selectElement = $('#' + id + ' select');
	var inputElement = $('#' + id + ' input');

	var showVisualChanges = false;
	var visualChangesType = '';

	if(selectElement.val().indexOf('IMAGE') >= 0)
	{
		showVisualChanges = true;
		visualChangesType = 'image';
	}
	else if(selectElement.val().indexOf('COLOR') >= 0)
	{
		if(jQuery().ColorPicker) 
		{
			inputElement.ColorPicker({
				onSubmit: function(hsb, hex, rgb, el) {
					$(el).val('#' + hex.toUpperCase());
					$(el).ColorPickerHide();
				},
				onBeforeShow: function () {
					$(this).ColorPickerSetColor(this.value);
				}
			}).bind('keyup', function(){
				$(this).ColorPickerSetColor(this.value);
			});
		} 
		else 
		{
			// get this action jest if color picker is not working
			showVisualChanges = true;
			visualChangesType = 'color';
		}
	}

	if(showVisualChanges == true && visualChangesType)
	{
		$('#visualChanges').css({
			display: 'block',
			left: inputElement.offset().left + 'px',
			top: (inputElement.offset().top+20) + 'px'
		});

		var value = inputElement.val();

		switch(visualChangesType)
		{
			case 'image':

				var image = 'none'; 
				var repeat = 'repeat';
				var position = '0 0';
				var color = '';

				if(value != 'none')
				{
					image = str_replace(searchPaths, replacePaths, value); 
					var img = new Image();
					img.src = image;
					var imgWidth = img.naturalWidth;
					var imgHeight = img.naturalHeight;

					if(imgWidth < 41 && imgHeight < 41)
					{
						repeat = ' no-repeat';
						position = ' 50% 50%';
					}

					color = '#FFFFFF ';
					image = 'url("' + image + '")';
				}

				$('#visualChangesValue').css({
					background: color + image + position + repeat
				});
			break;

			// get this action jest if color picker is not working
			case 'color':

				var iChars = "0123456789ABCDEF#"; 
				var badChar = 0;
				var hexColor = value.substr(0, 1) == '#' ? true : false;

				if(hexColor == true)
				{
					value = value.toUpperCase();
					self.value = value;
				}

				for (var i = 0; i < value.length; i++) 
				{
					if (iChars.indexOf(value.charAt(i)) < 0) 
					{
						badChar++;
						break;
					}
				}

				if(hexColor == true && (badChar || value.length > 7))
				{
					value = value.substr(0, value.length-1);
					self.value = value;

					alert((badChar ? 'Bad Char' : 'no more then 6 Chars'));
				}
				else
				{
					if(hexColor == true && (value.length < 4 || (value.length < 7 && value.length > 4)))
					{
						value = '';
					}

					$('#visualChangesValue').css({
						backgroundImage: 'none',
						backgroundColor: value
					});
				}
			break;
		}
	}
}

function add_tooltips_select(id, headline, sub_id)
{
	var links, i;
	
	head_text = headline;

	if (!document.getElementById || !document.getElementsByTagName)
	{
		return;
	}

	if (id == null)
	{
		links = document.getElementsByTagName('option');
	}
	else
	{
		links = document.getElementById(id).getElementsByTagName('option');
	}

	for (i = 0; i < links.length; i++)
	{
		if (sub_id)
		{
			if (links[i].parentNode.id.substr(0, sub_id.length) == sub_id)
			{
				prepare(links[i]);
			}
		}
		else
		{
			prepare(links[i]);
		}
	}

	tooltip_mode = 'select';
}

function randomString(string_length) 
{
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZ";
	var randomstring = '';

	for (var i=0; i < string_length; i++) 
	{
		var rnum = Math.floor(Math.random() * chars.length);
		randomstring += chars.substring(rnum, rnum+1);
	}

	return randomstring;
}

function ateTab(id)
{
	var childrens = document.getElementById('ateTabs').children;

	for(var i = 0; i < childrens.length; i++)
	{
		if(childrens.item(i).className == 'activetab')
		{
			childrens.item(i).removeAttribute('class');
			document.getElementById('Elements' + childrens.item(i).id).style.display = 'none';
			break;
		}
	}

	document.getElementById('ateTab' + id).setAttribute('class', 'activetab');
	document.getElementById('ElementsateTab' + id).style.display = 'block';
}

function checkRows(elements)
{
	var noElementsCheck = 0;

	for(var i = 0; i < elements.length; i++)
	{
		if(elements[i].style.display != 'none')
		{
			noElementsCheck++;
			break;
		}
	}

	return noElementsCheck;
}

function deleteElement(id)
{
	var answer = confirm(ateLang['DELETE_ELEMENT_MSG']);

	if(answer)
	{                                                                                                                             
		var element = $('#elementId' + id);
		var stored = element.attr('stored');

		element.slideUp('slow', function() {

			switch(stored)
			{
				case 'db': $(this).html("<input type='hidden' name='ate[" + id + "][delete]' value='1' />"); break;
				case 'js': $(this).remove(); break;
			}

			var elementsRows = $('#customElementsRows');
			var elements = elementsRows.children();
			var noElements = checkRows(elements);

			if(noElements <= 0)
			{
				elementsRows.append("<div id='noElements' style='padding: 10px 0; display: none;' class='row3'>" + ateLang['NO_ELEMENTS'] + "</div>");
				$('#noElements').slideDown('slow');
			}
		});
	}
}

function deleteReplacement(id, count)
{
	$('#' + id + '_' + count).css('display', 'none').html('');
}

function deleteFile(id)
{
	var answer = confirm(ateLang['DELETE_FILE_MSG']);

	if(answer)
	{                                                                                                                             
		var deleteIcon = $('#deleteFile' + id + ' a');
		deleteIcon.css('display', 'none');

		$('#deleteFile' + id).append('<div id="deleteFileLoader' + id + '"><img src="./../ate_files/ajax_loader2.gif" alt="' + ateLang['DELETING_PLEASE_WAIT'] + '" /> ' + ateLang['DELETING_PLEASE_WAIT'] + '</div>');

		$.post(ateLang['U_ACTION_CLEAN'] + "&operation=delete_uploaded&type=uploaded&file_id=" + id, {}, function(data) {

			if(data.indexOf('<!-- ajax: DELETED -->') >= 0)
			{
				$('#customFile' + id).slideUp('slow', function() {

					$(this).remove();

					var filesContainer = $('#filesContainer');
					var files = filesContainer.children();

					if(files.length <= 0)
					{
						filesContainer.html("<div id='noFiles' style='padding: 10px 0; display: none;' class='row3'>" + ateLang['NO_FILES'] + "</div>");
						$('#noFiles').slideDown('slow');
					}
				});
			}
			else
			{
				alert('Unknown Error');
				$('#deleteFileLoader' + id).remove();
				deleteIcon.css('display', '');
			}
		});
	}
}

function insertFileRow(fileId, fileName, fileDesc, fileSize)
{
	var filesContainer = $('#filesContainer');
	var rowsCount = filesContainer.children();
	var lastClass = rowsCount[(rowsCount.length-1)].id;
	lastClass = $('#' + lastClass + ' table tr').attr('class');
	var currentClass = (lastClass == 'row3' ? 4 : 3);

	var row = "<div id='customFile" + fileId + "' style='display: none;'>";
	row += "<table cellspacing='1' style='border: 0; padding: 0; background-color: transparent;'>";
	row += "<tr class='row" + currentClass + "'>";
	row += "<td style='width: 20%; text-align: " + ateLang['S_CONTENT_FLOW_BEGIN'] + "; padding: 5px;'>" + (fileDesc != '' ? fileDesc : fileName) + "</td>";
	row += "<td style='width: 50%; text-align: " + ateLang['S_CONTENT_FLOW_BEGIN'] + "; padding: 5px;' dir='ltr'>{T_ATE_PATH}/upload/" + fileName + "</td>";
	row += "<td style='width: 10%; padding: 5px;'>" + fileSize + "</td>";
	row += "<td style='width: 20%; padding: 5px;' id='deleteFile" + fileId + "'>";
	row += "<a href='javascript: deleteFile(\"" + fileId + "\");'>" + ateLang['ICON_DELETE'] + "</a>";
	row += "</td></tr></table></div>";

	filesContainer.append(row);
}

function insertElementRow()
{
	var id = randomString(40);
	var ElementsRows = $('#customElementsRows');
	var rowsCount = ElementsRows.children();
	var lastClass = rowsCount[(rowsCount.length-1)].id;
	lastClass = $('#' + lastClass + ' table tr').attr('class');
	var currentClass = (lastClass == 'row3' ? 4 : 3);

	var row = "<div id='elementId" + id + "' style='display: none;' stored='js'>";
	row += "<table cellspacing='1' style='border: 0; padding: 0; background-color: transparent;'>";
	row += "<tr class='row" + currentClass + "'>";
	row += "<td style='width: 2%;'>";
	row += "<a href='javascript: deleteElement(\"" + id + "\");' class='button2' style='padding: 0 4px'>X</a>";
	row += "</td>";
	row += "<td style='width: 10%; text-align: center; padding: 5px;'>";
	row += "<input type='text' name='ate[" + id + "][name]' value='' />";
	row += "</td>";
	row += "<td style='width: 30%;' valign='top'>";
	row += "<label for='ate[" + id + "][elements]'>";
	row += "<div style='margin-top: 10px;'>" + ateLang['ELEMENTS_EXPLAIN'] + "</div>";
	row += "<textarea dir='ltr' style='width: 95%; margin-bottom: 10px; font-size: 11px; height: 80px;' wrap='off' name='ate[" + id + "][elements]'></textarea>";
	row += "<input type='hidden' name='ate[" + id + "][section]' value='CUSTOM' />";
	row += "</label>";
	row += "</td>";
	row += "<td style='width: 58%; padding: 0 15px; text-align: " + ateLang['S_CONTENT_FLOW_BEGIN'] + "' valign='top'>";
	row += "<div id='" + id + "_replacements'>";
	row += "<div style='margin: 10px 0; text-align: center;'><a href='javascript: insertReplacementRow(\"" + id + "\"); add_tooltips_select(\"acp_template\", \"" + ateLang['TAG_EXPLAIN'] + "\");' class='button1'>" + ateLang['ADD_REPLACEMENT'] + "</a></div>";
	row += "</div></td></tr></table></div>";

	ElementsRows.append(row);

	return id;
}

function insertReplacementRow(elementId)
{
	var ElementReplacements = $('#' + elementId + '_replacements');
	var replacementCount = ElementReplacements.children();
	replacementCount = (replacementCount.length-1);
	var rows = $('.replacement').length;

	var row = "<div id='" + elementId + "_" + replacementCount + "' class='replacement' style='margin: 3px 0;'>";
	row += "<a href='javascript: deleteReplacement(\"" + elementId + "\", \"" + replacementCount + "\");' class='button2' style='padding: 0 4px'>X</a>";
	row += " <select onchange='changeInput(this, \"" + elementId + "\", \"" + replacementCount + "\");' name='ate[" + elementId + "][replacements][tag][]' style='width: 30%;'>";

	for(var i = 0; i < tags.length; i++)
	{
		row += "<option value='" + tags[i][0] + "' title='" + tags[i][2] + "'>" + tags[i][1] + "</option>";
	}

	row += "</select>";
	row += " <input type='text' dir='ltr' id='replacementValue" + elementId + replacementCount + "' onblur='removeVisualChanges();' onkeyup='insertVisualChanges(\"" + elementId + "_" + replacementCount + "\");' onfocus='insertVisualChanges(\"" + elementId + "_" + replacementCount + "\");' autocomplete='off' name='ate[" + elementId + "][replacements][value][]' row='" + rows + "' value='' style='width: 62%;' />";
	row += "</div>";

	ElementReplacements.append(row);
}

function str_replace (search, replace, subject, count) 
{
	f = [].concat(search),
	r = [].concat(replace),
	s = subject,
	ra = r instanceof Array, sa = s instanceof Array;    s = [].concat(s);

	if (count) 
	{
		this.window[count] = 0;
	}

	for (i=0, sl=s.length; i < sl; i++) 
	{
		if (s[i] === '') 
		{
			continue;
		}

		for (j=0, fl=f.length; j < fl; j++) 
		{
			temp = s[i]+'';
			repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
			s[i] = (temp).split(f[j]).join(repl);

			if (count && s[i] !== temp) 
			{
				this.window[count] += (temp.length-s[i].length)/f[j].length;
			}
		}
	}

	return sa ? s : s[0];
}

function in_array(needle, haystack, argStrict) 
{
	var key = '', strict = !!argStrict; 

	if (strict) 
	{
		for (key in haystack) 
		{
			if (haystack[key] === needle) 
			{
				return true;
			}
		}
	} 
	else 
	{
		for (key in haystack) 
		{
			if (haystack[key] == needle) 
			{
				return true;
			}
		}
	}

	return false;
}

function changeInput(self, elementId, replacementCount)
{
	var Properties 	= new Array('BG-REPEAT', 'BG-ATTACHMENT', 'FONT-WEIGHT', 'TEXT-ALIGN', 'TEXT-DECORATION', 'FONT-VARIANT', 'BORDER-TOP-STYLE', 'BORDER-RIGHT-STYLE', 'BORDER-LEFT-STYLE', 'BORDER-BOTTOM-STYLE');
	var parent 	= $('#' + elementId + '_' + replacementCount);
	var replacement = $('#replacementValue' + elementId + replacementCount);
	var row 	= null;
	var selected 	= '';
	var lang	= '';

	if(in_array(self.value, Properties) == true)
	{
		Properties['BG-REPEAT'] 		= ['repeat', 'no-repeat', 'repeat-x', 'repeat-y', 'inherit'];
		Properties['BG-ATTACHMENT'] 		= ['scroll', 'fixed', 'inherit'];
		Properties['FONT-WEIGHT']	 	= ['normal', 'bold', 'bolder', 'lighter', '100', '200', '300', '400', '500', '600', '700', '800', '900'];
		Properties['TEXT-ALIGN'] 		= ['left', 'right', 'center', 'justify'];
		Properties['TEXT-DECORATION']	 	= ['none', 'underline', 'overline', 'line-through', 'blink'];
		Properties['FONT-VARIANT'] 		= ['normal', 'small-caps', 'inherit'];
		Properties['BORDER-TOP-STYLE'] 		= ['none', 'hidden', 'dotted', 'dashed', 'solid', 'double', 'groove', 'ridge', 'inset', 'outset', 'inherit'];
		Properties['BORDER-RIGHT-STYLE'] 	= Properties['BORDER-TOP-STYLE'];
		Properties['BORDER-LEFT-STYLE'] 	= Properties['BORDER-TOP-STYLE'];
		Properties['BORDER-BOTTOM-STYLE'] 	= Properties['BORDER-TOP-STYLE'];


		row = "<select id='" + replacement.attr('id') + "' name='" + replacement.attr('name') + "'>";

		$.each(Properties[self.value], function(i, data) {

			selected = replacement.val() == data ? ' selected="selected"' : '';
			lang = (ateLang[data.toUpperCase()] == undefined) ? data : ateLang[data.toUpperCase()];
			row += "<option value='" + data + "'" + selected + ">" + lang + "</option>";
		});

		row += "</select>";
	}
	else if(replacement.is('select'))
	{
		row = "<input type='text' id='" + replacement.attr('id') + "' dir='ltr' onblur='removeVisualChanges();' onkeyup='insertVisualChanges(\"" + elementId + "_" + replacementCount + "\");' onfocus='insertVisualChanges(\"" + elementId + "_" + replacementCount + "\");' autocomplete='off' name='" + replacement.attr('name') + "' value='' style='width: 62%;' />";
	}

	if(row != null)
	{
		replacement.remove();
		parent.append(row);
	}
}
