<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ATE template for prosilver based styles
*/

$template = array(
	// Main elements
	array(
		'element_code' => 'HTML',
		'element_name' => 'HTML',
		'element_section' => 'MAIN',
		'element_elements' => '|html, body|>|html|>|body|', 
		'element_replacements' => 'COLOR|#536482>BG-COLOR|#FFFFFF'),
	array(
		'element_code' => 'WRAPER',
		'element_name' => 'WRAPER',
		'element_section' => 'MAIN',
		'element_elements' => '|#wrap|', 
		'element_replacements' => 'PADDING-RIGHT|20px>PADDING-LEFT|20px'),
	array(
		'element_code' => 'HEADER',
		'element_name' => 'HEADER',
		'element_section' => 'MAIN',
		'element_elements' => '|.headerbar|', 
		'element_replacements' => 'BG-COLOR|#12A3EB>BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/bg_header.gif")'),
	array(
		'element_code' => 'BODY',
		'element_name' => 'BODY',
		'element_section' => 'MAIN',
		'element_elements' => '|#page-body|', 
		'element_replacements' => 'MARGIN-TOP|4px>MARGIN-LEFT|0px>MARGIN-BOTTOM|4px>MARGIN-RIGHT|0px'),
	array(
		'element_code' => 'FORUM_LIST1',
		'element_name' => 'FORUM_LIST1',
		'element_section' => 'MAIN',
		'element_elements' => '|.forabg|', 
		'element_replacements' => 'BG-COLOR|#0076B1>BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/bg_list.gif")>MARGIN-BOTTOM|4px>PADDING-TOP|0px>PADDING-LEFT|5px>PADDING-BOTTOM|0px>PADDING-RIGHT|5px'),
	array(
		'element_code' => 'FORUM_LIST2',
		'element_name' => 'FORUM_LIST2',
		'element_section' => 'MAIN',
		'element_elements' => '|.forumbg|', 
		'element_replacements' => 'BG-COLOR|#12A3EB>BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/bg_header.gif")'),
	array(
		'element_code' => 'NAVBAR',
		'element_name' => 'NAVBAR',
		'element_section' => 'MAIN',
		'element_elements' => '|.navbar|', 
		'element_replacements' => 'BG-COLOR|#cadceb'),
	array(
		'element_code' => 'PANEL',
		'element_name' => 'PANEL',
		'element_section' => 'MAIN',
		'element_elements' => '|.panel|', 
		'element_replacements' => 'BG-COLOR|#ECF1F3>COLOR|#28313F'),
	array(
		'element_code' => 'INPUTS',
		'element_name' => 'INPUTS',
		'element_section' => 'MAIN',
		'element_elements' => '|.inputbox|', 
		'element_replacements' => 'BG-COLOR|#FFFFFF>BORDER-TOP-STYLE|solid>BORDER-RIGHT-STYLE|solid>BORDER-BOTTOM-STYLE|solid>BORDER-LEFT-STYLE|solid>BORDER-TOP-WIDTH|1px>BORDER-RIGHT-WIDTH|1px>BORDER-BOTTOM-WIDTH|1px>BORDER-LEFT-WIDTH|1px>BORDER-TOP-COLOR|#B4BAC0>BORDER-RIGHT-COLOR|#B4BAC0>BORDER-BOTTOM-COLOR|#B4BAC0>BORDER-LEFT-COLOR|#B4BAC0>COLOR|#333333>PADDING-TOP|2px>PADDING-RIGHT|2px>PADDING-BOTTOM|2px>PADDING-LEFT|2px'),
	array(
		'element_code' => 'INPUTS_HOVER',
		'element_name' => 'INPUTS_HOVER',
		'element_section' => 'MAIN',
		'element_elements' => '|.inputbox:hover|', 
		'element_replacements' => 'BORDER-TOP-STYLE|solid>BORDER-RIGHT-STYLE|solid>BORDER-BOTTOM-STYLE|solid>BORDER-LEFT-STYLE|solid>BORDER-TOP-WIDTH|1px>BORDER-RIGHT-WIDTH|1px>BORDER-BOTTOM-WIDTH|1px>BORDER-LEFT-WIDTH|1px>BORDER-TOP-COLOR|#11A3EA>BORDER-RIGHT-COLOR|#11A3EA>BORDER-BOTTOM-COLOR|#11A3EA>BORDER-LEFT-COLOR|#11A3EA'),

	// Corners elements
	array(
		'element_code' => 'CORNERS_LEFT',
		'element_name' => 'CORNERS_LEFT',
		'element_section' => 'CORNERS',
		'element_elements' => '|span.corners-top|>|span.corners-bottom|', 
		'element_replacements' => 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/corners_left.png")'),
	array(
		'element_code' => 'CORNERS_RIGHT',
		'element_name' => 'CORNERS_RIGHT',
		'element_section' => 'CORNERS',
		'element_elements' => '|span.corners-top span|>|span.corners-bottom span|', 
		'element_replacements' => 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/corners_right.png")'),
	array(
		'element_code' => 'CORNERS_LEFT_INSIDE2',
		'element_name' => 'CORNERS_LEFT_INSIDE2',
		'element_section' => 'CORNERS',
		'element_elements' => '|#cp-main span.corners-top, #cp-menu span.corners-top|>|#cp-main span.corners-bottom, #cp-menu span.corners-bottom|', 
		'element_replacements' => 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/corners_left2.gif")'),
	array(
		'element_code' => 'CORNERS_RIGHT_INSIDE2',
		'element_name' => 'CORNERS_RIGHT_INSIDE2',
		'element_section' => 'CORNERS',
		'element_elements' => '|#cp-main span.corners-top span, #cp-menu span.corners-top span|>|#cp-main span.corners-bottom span, #cp-menu span.corners-bottom span|', 
		'element_replacements' => 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/corners_right2.gif")'),
	array(
		'element_code' => 'CORNERS_LEFT_INSIDE',
		'element_name' => 'CORNERS_LEFT_INSIDE',
		'element_section' => 'CORNERS',
		'element_elements' => '|#cp-main .panel #topicreview span.corners-top, #cp-menu .panel #topicreview span.corners-top|>|#cp-main .panel #topicreview span.corners-bottom, #cp-menu .panel #topicreview span.corners-bottom|', 
		'element_replacements' => 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/corners_left.gif")'),
	array(
		'element_code' => 'CORNERS_RIGHT_INSIDE',
		'element_name' => 'CORNERS_RIGHT_INSIDE',
		'element_section' => 'CORNERS',
		'element_elements' => '|#cp-main .panel #topicreview span.corners-top span, #cp-menu .panel #topicreview span.corners-top span|>|#cp-main .panel #topicreview span.corners-bottom span, #cp-menu .panel #topicreview span.corners-bottom span|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/corners_right.gif")'),

	// Polls elements
	array(
		'element_code' => 'POLL1',
		'element_name' => 'POLL1',
		'element_section' => 'POLLS',
		'element_elements' => '|.pollbar1|', 
		'element_replacements'	=> 'BG-COLOR|#AA2346>BORDER-BOTTOM-COLOR|#74162C>BORDER-RIGHT-COLOR|#74162C'),
	array(
		'element_code' => 'POLL2',
		'element_name' => 'POLL2',
		'element_section' => 'POLLS',
		'element_elements' => '|.pollbar2|', 
		'element_replacements'	=> 'BG-COLOR|#BE1E4A>BORDER-BOTTOM-COLOR|#8C1C38>BORDER-RIGHT-COLOR|#8C1C38'),
	array(
		'element_code' => 'POLL3',
		'element_name' => 'POLL3',
		'element_section' => 'POLLS',
		'element_elements' => '|.pollbar3|', 
		'element_replacements'	=> 'BG-COLOR|#D11A4E>BORDER-BOTTOM-COLOR|#AA2346>BORDER-RIGHT-COLOR|#AA2346'),
	array(
		'element_code' => 'POLL4',
		'element_name' => 'POLL4',
		'element_section' => 'POLLS',
		'element_elements' => '|.pollbar4|', 
		'element_replacements'	=> 'BG-COLOR|#E41653>BORDER-BOTTOM-COLOR|#BE1E4A>BORDER-RIGHT-COLOR|#BE1E4A'),
	array(
		'element_code' => 'POLL5',
		'element_name' => 'POLL5',
		'element_section' => 'POLLS',
		'element_elements' => '|.pollbar5|', 
		'element_replacements'	=> 'BG-COLOR|#F81157>BORDER-BOTTOM-COLOR|#D11A4E>BORDER-RIGHT-COLOR|#D11A4E'),

	// Icons elements
	array(
		'element_code' => 'ICON_ONLINE',
		'element_name' => 'ICON_ONLINE',
		'element_section' => 'ICONS',
		'element_elements' => '|.online|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_IMAGESET_LANG_PATH--end--*/icon_user_online.gif")'),
	array(
		'element_code' => 'ICON_HOME',
		'element_name' => 'ICON_HOME',
		'element_section' => 'ICONS',
		'element_elements' => '|.sitehome|>|.icon-home|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_home.gif")'),
	array(
		'element_code' => 'ICON_FAQ',
		'element_name' => 'ICON_FAQ',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-faq|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_faq.gif")'),
	array(
		'element_code' => 'ICON_MEMBERS',
		'element_name' => 'ICON_MEMBERS',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-members|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_members.gif")'),
	array(
		'element_code' => 'ICON_UCP',
		'element_name' => 'ICON_UCP',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-ucp|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_ucp.gif")'),
	array(
		'element_code' => 'ICON_REGISTER',
		'element_name' => 'ICON_REGISTER',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-register|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_register.gif")'),
	array(
		'element_code' => 'ICON_LOGOUT',
		'element_name' => 'ICON_LOGOUT',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-logout|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_logout.gif")'),
	array(
		'element_code' => 'ICON_BOOKMARK',
		'element_name' => 'ICON_BOOKMARK',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-bookmark|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_bookmark.gif")'),
	array(
		'element_code' => 'ICON_BUMP',
		'element_name' => 'ICON_BUMP',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-bump|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_bump.gif")'),
	array(
		'element_code' => 'ICON_SUBSCRIBE',
		'element_name' => 'ICON_SUBSCRIBE',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-subscribe|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_subscribe.gif")'),
	array(
		'element_code' => 'ICON_UNSUBSCRIBE',
		'element_name' => 'ICON_UNSUBSCRIBE',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-unsubscribe|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_unsubscribe.gif")'),
	array(
		'element_code' => 'ICON_PAGES',
		'element_name' => 'ICON_PAGES',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-pages|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_pages.gif")'),
	array(
		'element_code' => 'ICON_SEARCH',
		'element_name' => 'ICON_SEARCH',
		'element_section' => 'ICONS',
		'element_elements' => '|.icon-search|', 
		'element_replacements'	=> 'BG-IMAGE|url("*--start--T_THEME_PATH--end--*/images/icon_search.gif")'),
);

?>