<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if (!defined('IN_PHPBB'))
{
	exit;
}


class ate
{
	var $css_content 	= '';
	var $u_action 		= '';
	var $ate_id 		= 0;
	var $uploading 		= false;
	var $paths 		= array('uploaded' => "ate_files/upload/", 'backup' => "ate_files/backup/", 'xml' => "ate_files/xml/");
	var $complex_styles 	= array('background', 'border', 'border-top', 'border-right', 'border-bottom', 'border-left', 'border-style', 'border-color', 'border-width', 'font', 'margin', 'padding');
	var $styles 		= array('prosilver', 'subsilver2');
	var $tags 		= array(
		'BG-COLOR'		=> 'background-color',
		'BG-ATTACHMENT'		=> 'background-attachment',
		'BG-IMAGE'		=> 'background-image',
		'BG-POSITION'		=> 'background-position',
		'BG-REPEAT'		=> 'background-repeat',

		'BORDER-BOTTOM-COLOR'	=> 'border-bottom-color',
		'BORDER-BOTTOM-STYLE'	=> 'border-bottom-style',
		'BORDER-BOTTOM-WIDTH'	=> 'border-bottom-width',
		'BORDER-LEFT-STYLE'	=> 'border-left-style',
		'BORDER-LEFT-COLOR'	=> 'border-left-color',
		'BORDER-LEFT-WIDTH'	=> 'border-left-width',
		'BORDER-RIGHT-COLOR'	=> 'border-right-color',
		'BORDER-RIGHT-STYLE'	=> 'border-right-style',
		'BORDER-RIGHT-WIDTH'	=> 'border-right-width',
		'BORDER-TOP-COLOR'	=> 'border-top-color',
		'BORDER-TOP-STYLE'	=> 'border-top-style',
		'BORDER-TOP-WIDTH'	=> 'border-top-width',

		'COLOR'			=> 'color',
		'TEXT-ALIGN'		=> 'text-align',
		'TEXT-DECORATION'	=> 'text-decoration',

		'FONT-FAMILY'		=> 'font-family',
		'FONT-SIZE'		=> 'font-size',
		'FONT-STYLE'		=> 'font-style',
		'FONT-VARIANT'		=> 'font-variant',
		'FONT-WEIGHT'		=> 'font-weight',

		'MARGIN-BOTTOM'		=> 'margin-bottom',
		'MARGIN-LEFT'		=> 'margin-left',
		'MARGIN-RIGHT'		=> 'margin-right',
		'MARGIN-TOP'		=> 'margin-top',

		'PADDING-BOTTOM'	=> 'padding-bottom',
		'PADDING-LEFT'		=> 'padding-left',
		'PADDING-RIGHT'		=> 'padding-right',
		'PADDING-TOP'		=> 'padding-top',

		'WIDTH'			=> 'width',
		'MIN-WIDTH'		=> 'min-width',
		'MAX-WIDTH'		=> 'max-width',

		'HEIGHT'		=> 'height',
		'MIN-HEIGHT'		=> 'min-height',
		'MAX-HEIGHT'		=> 'max-height',
	);

	function debug($array, $title = '')
	{
		echo $title . "<br />";
		echo "<div dir='ltr'><pre>";
		print_r($array);
		echo "</pre></div>";
	}

	/*
	* Checking the latest version of Advanced Theme Editor
	**/
	function check_latest_version($force_update = false, $warn_fail = false, $ttl = 86400)
	{
		global $cache;

		$info = $cache->get('ateversioncheck');

		if ($info === false || $force_update)
		{
			$errstr = '';
			$errno = 0;

			$info = get_remote_file('www.dd-design.co.il', '/versioncheck/ate', 'version.txt', $errstr, $errno);

			if ($info === false)
			{
				$cache->destroy('ateversioncheck');
				if ($warn_fail)
				{
					trigger_error($errstr, E_USER_WARNING);
				}
				return false;
			}
	
			$cache->put('ateversioncheck', $info, $ttl);
		}
	
		return $info;
	}

	/*
	* Collect the theme data and save it on the css_content class var
	**/
	function load_css($content = '')
	{
		$this->css_content = $content;
		$this->css_content = ereg_replace("[ \t\n\r]+", " ", $this->css_content);
		$this->css_content = $this->handle_notes($this->css_content);
		$this->css_content = $this->manage_phpbb_tags($this->css_content);
	}

	/*
	* Removing all css notes
	**/
	function handle_notes($content)
	{
		$content = preg_replace("/\/\*(.*?)\*\//", "", $content);
		return $content;
	}

	/*
	* Replacing the phpbb tags "{}" in temp tags
	**/
	function manage_phpbb_tags($content, $action = 'replace')
	{
		switch($action)
		{
			case 'replace':
				$content = preg_replace("/\{([A-Z0-9_]+)\}/", "*--start--\\1--end--*", $content);
			break;

			case 'restore':
				$content = preg_replace("/\*--start--([A-Z0-9_]+)--end--\*/", "{\\1}", $content);
			break;
		}

		return $content;
	}

	/*
	* Create new elements for the custom section
	**/
	function new_element($elements, $replacements)
	{
		$properties = array();

		if(sizeof($replacements))
		{
			foreach($replacements as $key => $value)
			{
				$properties[] = "{$this->tags[$key]}: {$value} !important;";
			}
		}

		return str_replace("|", "", implode(", ", $elements)) . " { " . implode(" ", $properties) . " }";
	}

	function replace_values($theme_data, $ate_id)
	{
		$this->load_css($theme_data);
		$data_ary = $this->create_array($ate_id);

		if(!sizeof($data_ary))
		{
			return $theme_data;
		}

		for($i = 0; $i < count($data_ary); ++$i)
		{
			$custom_elements = array();

			foreach($data_ary[$i]['elements'] as $element)
			{
				$data = $this->match_values($element, $this->css_content);

				/*
				* collect all none match custom elements
				**/
				if($data_ary[$i]['section'] == 'CUSTOM' && !sizeof($data['matches']))
				{
					$custom_elements[] = $element;
				}

				for($count = 0; $count < count($data['matches']); ++$count)
				{
					$data['matches'][$count][0] = $this->remove_spaces($data['matches'][$count][0]);
					$data['matches'][$count][0] = substr($data['matches'][$count][0], 0, 1) == "}" ? substr($data['matches'][$count][0], 1) : $data['matches'][$count][0];
					$manage_values = $this->manage_values($data['matches'][$count][$data['block_num']], $data_ary[$i]['replacements']);
					$managed = preg_replace("/\{(.*?)\}/", '{ '.implode(' ', $manage_values).' }', $data['matches'][$count][0]);

					$this->css_content = str_replace($data['matches'][$count][0], $managed, $this->css_content);
				}
			}

			/*
			* create new element for none found custom elements
			**/
			if(sizeof($custom_elements))
			{
				$this->css_content .= $this->new_element($custom_elements, $data_ary[$i]['replacements']);
			}
		}

		$this->css_content = str_replace(array("; }", ";}"), array("; }\r\n", "; }\r\n"), $this->css_content);
		$this->css_content = $this->remove_spaces($this->css_content, 'lines');
		$this->css_content = $this->manage_phpbb_tags($this->css_content, 'restore');

		return $this->css_content;
	}

	function match_values($element = '', $css = '')
	{
		$data = array('block_num' => 4, 'matches' => array());

		$empty_befor = $empty_after = false;

		if(strpos($element, "|") !== false)
		{
			$empty_befor = substr($element, 0, 1) == "|" ? true : false;
			$empty_after = substr($element, -1, 1) == "|" ? true : false;
			$element = str_replace("|", "", $element);

			if($empty_befor && $empty_after)
			{
				$pattern = "/\s*(^|\})\s*($element)\s*\{(.*?)\}/";
				$data['block_num'] = 3;
			}
			elseif($empty_befor)
			{
				$pattern = "/\s*(^|\})\s*($element)\s*([\w\.\s\,]*)\s*\{(.*?)\}/";
			}
			elseif($empty_after)
			{
				$pattern = "/\s*([^\}]*?)($element)\s*\{(.*?)\}/";
				$data['block_num'] = 3;
			}
		}
		else
		{
			$pattern = "/\s*([^\}]*?)($element)\s*([\w\.\s\,]*)\s*\{(.*?)\}/";
		}

		if($pattern)
		{
			preg_match_all($pattern, $css, $data['matches'], PREG_SET_ORDER);
		}

		return $data;
	}

	function manage_values($values, $replacements, $reverse = false)
	{
		preg_match_all("/(.*?)\;/", $values, $clean_values, PREG_SET_ORDER);

		$inside = $new_clean_values = array();

		for($i = 0; $i < count($clean_values); ++$i)
		{
			$clean_values[$i][0] = $this->remove_spaces($clean_values[$i][0]);
			$row = explode(":", $clean_values[$i][0]);
			$row = trim($row[0]);

			if(!$inside[$row])
			{
				if(in_array($row, $this->complex_styles))
				{
					$new_clean_values = array_merge($new_clean_values, $this->manage_complex_style($row, $clean_values));
					$inside[$row] = 1;
				}
				elseif(trim($clean_values[$i][0]) != '')
				{
					$new_clean_values[] = $clean_values[$i][0];
				}
			}
		}

		$output = array();

		if(!$reverse)
		{
			$create = $replacements;

			for($i = 0; $i < count($new_clean_values); ++$i)
			{
				list($row_key, $row_value) = explode(":", $new_clean_values[$i]);
				$key = array_search(trim($row_key), $this->tags); 

				$output[$i] = $new_clean_values[$i];

				if(in_array(trim($row_key), array_values($this->tags)) && isset($replacements[$key]))
				{
					$output[$i] = "{$row_key}: {$replacements[$key]};";
					unset($create[$key]);
				}
			}

			/*
			* create new elements from the requested replacements
			**/
			if(sizeof($create))
			{
				foreach($create as $key => $value)
				{
					$output[] = "{$this->tags[$key]}: {$value};";
				}
			}
		}
		else
		{
			for($i = 0; $i < count($new_clean_values); ++$i)
			{
				list($row_key, $row_value) = explode(":", $new_clean_values[$i]);
				$row_value = str_replace(";", "", trim($row_value));

				if(in_array(trim($row_key), array_values($this->tags)) && trim($row_value) != '')
				{
					$key = array_search(trim($row_key), $this->tags); 

					/*
					* find and get only the requested value from the css map
					* if you want to get all style allowed values remove the IF case
					**/
					//if(isset($replacements[$key]))
					{
						$output[$key] = $row_value;
					}
				}
			}
		}

		return $output;
	}

	function insert_values($var = array(), $ate_id = 0)
	{
		global $db, $user;

		if($ate_id <= 0 || !sizeof($var))
		{
			return;
		}

		$error = $new_data = $error_output = array();

		foreach($var as $element_code => $data)
		{
			if($data['delete'])
			{
				$this->delete_element($element_code, $ate_id);
				continue;
			}

			$element_code = strtoupper($element_code);
			$elements_ary_data = array();
			$elements_ary = explode("\r\n", $data['elements']);

			for($i = 0; $i < count($elements_ary); ++$i)
			{
				if(trim($elements_ary[$i]) != '')
				{
					$elements_ary_data[] = $elements_ary[$i];
				}
			}

			$check_tag_duplication = array();
			$replacements_ary_data = array();

			$loops = count($data['replacements']['tag']);

			for($i = 0; $i < $loops; ++$i)
			{
				$errors = array();

				$tag = strtoupper($data['replacements']['tag'][$i]);
				$value = $data['replacements']['value'][$i];

				if(!in_array($tag, array_keys($this->tags)))
				{
					$errors[] = $user->lang['ERROR_UNKNOWN_TAG'];
				}

				if(trim($value) == '')
				{
					$errors[] = $user->lang['ERROR_EMPTY_VALUE'];
				}

				if(strpos($tag, 'COLOR') !== false && strpos($value, '#') !== false)
				{
					$checking_value = str_replace("#", "", $value);

					if(!in_array(strlen($checking_value), array(3, 6)))
					{
						$errors[] = $user->lang['ERROR_NOT_COLOR_STRING'];
					}
					else
					{
						$value_ary = str_split($checking_value);

						for($color_count = 0; $color_count < count($value_ary); ++$color_count)
						{
							if(!in_array(strtoupper($value_ary[$color_count]), array('A', 'B', 'C', 'D', 'E', 'F', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9')))
							{
								$errors[] = $user->lang['ERROR_NOT_COLOR_STRING'];
								break;
							}
						}
					}
				}

				if(isset($check_tag_duplication[$tag]))
				{
					$error[$element_code][$tag] = $user->lang['ERROR_DUPLICATE_TAG'];
				}
				elseif(sizeof($errors))
				{
					$error[$element_code][$tag] = implode(", ", $errors);
				}

				$check_tag_duplication[$tag] = true;

				$value = $this->handle_values($tag, $value, true, (sizeof($errors) ? true : false));

				$replacements_ary_data[] = "{$tag}|{$value}";
			}

			$new_data[$element_code]['section'] = $data['section'];
			$new_data[$element_code]['name'] = $data['name'];
			$new_data[$element_code]['elements'] = implode(">", $elements_ary_data);
			$new_data[$element_code]['replacements'] = implode(">", $replacements_ary_data);
		}

		if(sizeof($new_data))
		{
			foreach($new_data as $element_code => $data)
			{
				if(sizeof($error) || $this->uploading)
				{
					$error_output[] = array(
						'element_code'		=> $element_code,
						'element_name'		=> $data['name'],
						'element_section'	=> $data['section'],
						'element_elements'	=> $data['elements'],
						'element_replacements'	=> $data['replacements'],
						'element_error'		=> $this->uploading ? null : $error[$element_code],
						'is_error'		=> isset($error[$element_code]) && !$this->uploading ? 1 : 0,
					);
				}
				else
				{
					$sql = "SELECT *
						FROM " . STYLES_ATE_ELEMENTS_TABLE . "
						WHERE ate_id = '{$ate_id}'
						AND element_code = '{$element_code}'";
					$result = $db->sql_query($sql);
					$element_data = $db->sql_fetchrow($result);

					if(intval($element_data['element_id']) > 0)
					{
						$sql = "UPDATE "  . STYLES_ATE_ELEMENTS_TABLE . "
							SET element_elements = '{$data['elements']}', element_replacements = '{$data['replacements']}'
							WHERE element_id = '{$element_data['element_id']}'";
						$db->sql_query($sql);
					}
					else
					{
						$this->insert_custom_elements($ate_id, $data['name'], $element_code, $data['elements'], $data['replacements']);
					}
				}
			}
		}

		return $error_output;
	}

	function remove_spaces($string, $type = 'start', $element = '')
	{
		$loops = strlen($string);

		switch($type)
		{
			case 'start':
				for($i = 0; $i < $loops; ++$i)
				{
					if(substr($string, 0, 1) == " ")
					{
						$string = substr($string, 1);
					}
					else
					{
						break;
					}
				}
			break;

			case 'end':
				for($i = 0; $i < $loops; ++$i)
				{
					if(substr($string, -1) == " ")
					{
						$string = substr($string, 0, -1);
					}
					else
					{
						break;
					}
				}
			break;

			case 'start-end':

				$string = $this->remove_spaces($string, 'start', $element);
				$string = $this->remove_spaces($string, 'end', $element);

			break;

			case 'multi':
				$string = ereg_replace("[ \t\n\r]+", " ", $string);
			break;

			case 'element':
			case 'lines':
				$string_ary = explode(($element ? $element : "\r\n"), $string);

				if(sizeof($string_ary))
				{
					foreach($string_ary as $line)
					{
						$data[] = $this->remove_spaces($line);
					}
				}

				$string = implode(($element ? $element . " " : "\r\n"), $data);
			break;
		}

		return $string;
	}

	function manage_complex_style($type = '', $values)
	{
		$new_vras = array();

		foreach($values as $value)
		{
			list($value_type, $values) = explode(":", $value[0]);

			if(trim($value_type) == $type)
			{
				$values = substr($values, 0, -1);
				$values = " " . $values . " ";

				switch($type)
				{
					case 'background':

						/*
						* Find if background !important is exists
						**/
						$important = $this->strpos_ary($values, array('!important', '! important'));

						if(isset($important))
						{
							$values = str_replace($important, "", $values);
						}

						/*
						* Check if background elements is inherit
						**/
						if(trim($values) == 'inherit')
						{
							$new_var[$type . '-image'] = $new_var[$type . '-repeat'] = $new_var[$type . '-attachment'] = $new_var[$type . '-position'] = $new_var[$type . '-color'] = 'inherit' . ($important ? ' ' . $important : '');
							break;
						}

						/*
						* remove all inherit values
						**/
						$values = str_replace("inherit", "", $values);

						/*
						* Find if background image is exists
						**/
						preg_match("/url\s*\(\s*(.*?)\s*\)/", $values, $image_match['url']);
						preg_match("/none/", $values, $image_match['none']);

						if(sizeof($image_match['url']) || sizeof($image_match['none']))
						{
							$image_value = sizeof($image_match['url']) ? $image_match['url'][0] : $image_match['none'][0];
							$values = str_replace($image_value, "", $values);
							$new_var[$type . '-image'] = $image_value . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if background repeat is exists
						**/
						preg_match("/([\-no]*)repeat([\-xy]*)/", $values, $repeat_match);

						if($repeat_match[0])
						{
							$values = str_replace($repeat_match[0], "", $values);
							$new_var[$type . '-repeat'] = $repeat_match[0] . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if background attachment is exists
						**/
						$attachment_value = $this->strpos_ary($values, array('scroll', 'fixed'));

						if(isset($attachment_value))
						{
							$values = str_replace($attachment_value, "", $values);
							$new_var[$type . '-attachment'] = $attachment_value . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if background position is exists
						**/
						$position_value = $this->strpos_ary($values, array('left top', 'left center', 'left bottom', 'right top', 'right center', 'right bottom', 'center top', 'center center', 'center bottom'));

						if(!isset($position_value))
						{
							$combinations = array(
								"/([0-9\-]+)\s([0-9\-]+)/", 
								"/([0-9\-]+)px\s([0-9\-]+)/", 
								"/([0-9\-]+)\s([0-9\-]+)px/", 
								"/([0-9\-]+)%\s([0-9\-]+)/", 
								"/([0-9\-]+)\s([0-9\-]+)%/", 
								"/([0-9\-]+)px\s([0-9\-]+)px/", 
								"/([0-9\-]+)%\s([0-9\-]+)%/",
								"/([0-9\-]+)%\s([0-9\-]+)px/", 
								"/([0-9\-]+)px\s([0-9\-]+)%/",
								"/([0-9\-]+)%\s(top)/",
								"/([0-9\-]+)%\s(bottom)/",
								"/([0-9\-]+)%\s(middle)/",
								"/([0-9\-]+)px\s(top)/",
								"/([0-9\-]+)px\s(bottom)/",
								"/([0-9\-]+)px\s(middle)/",
								"/([0-9\-]+)\s(top)/",
								"/([0-9\-]+)\s(bottom)/",
								"/([0-9\-]+)\s(middle)/",
								"/(right)\s([0-9\-]+)%/",
								"/(left)\s([0-9\-]+)%/",
								"/(center)\s([0-9\-]+)%/",
								"/(right)\s([0-9\-]+)px/",
								"/(left)\s([0-9\-]+)px/",
								"/(center)\s([0-9\-]+)px/",
								"/(right)\s([0-9\-]+)/",
								"/(left)\s([0-9\-]+)/",
								"/(center)\s([0-9\-]+)/",
							);

							for($i = 0; $i < count($combinations); ++$i)
							{
								$position_match = array();
								preg_match($combinations[$i], $values, $position_match);

								if($position_match[0])
								{
									$position_value = $position_match[0];
									break;
								}
							}
						}

						if(isset($position_value))
						{
							$values = str_replace($position_value, "", $values);
							$new_var[$type . '-position'] = $position_value . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if background color is exists
						* if somting is left in the values var it must be the color
						**/
						$new_var[$type . '-color'] = trim($values) . ($important ? ' ' . $important : '');
					break;

					case 'border-top':
					case 'border-right':
					case 'border-bottom':
					case 'border-left':
					case 'border':

						$loops = ($type == 'border') ? array('-top', '-right', '-bottom', '-left') : array('');

						/*
						* Find if border !important is exists
						**/
						$important = $this->strpos_ary($values, array('!important', '! important'));

						if(isset($important))
						{
							$values = str_replace($important, "", $values);
						}

						/*
						* Check if border elements is inherit
						**/
						if(trim($values) == 'inherit')
						{
							for($i = 0; $i < count($loops); ++$i)
							{
								$new_var[$type . $loops[$i] . '-style'] = $new_var[$type . $loops[$i] . '-width'] = $new_var[$type . $loops[$i] . '-color'] = 'inherit' . ($important ? ' ' . $important : '');
							}
							break;
						}

						/*
						* remove all inherit values
						**/
						$values = str_replace("inherit", "", $values);

						/*
						* Find if border style is exists
						**/
						$style_value = $this->strpos_ary($values, array('none', 'hidden', 'dotted', 'dashed', 'solid', 'double', 'groove', 'ridge', 'inset', 'outset'));

						if(isset($style_value))
						{
							$values = str_replace($style_value, "", $values);

							for($i = 0; $i < count($loops); ++$i)
							{
								$new_var[$type . $loops[$i] . '-style'] = $style_value . ($important ? ' ' . $important : '');
							}

							if(trim($values) == '') break;
						}

						/*
						* Find if border width is exists
						**/
						preg_match("/([0-9]+)([px]*)([%]*)/", $values, $width_match);

						if($width_match[0])
						{
							$values = str_replace($width_match[0], "", $values);

							for($i = 0; $i < count($loops); ++$i)
							{
								$new_var[$type . $loops[$i] . '-width'] = $width_match[0] . ($important ? ' ' . $important : '');
							}

							if(trim($values) == '') break;
						}

						/*
						* Find if border color is exists
						* if somting is left in the values var it must be the color
						**/
						for($i = 0; $i < count($loops); ++$i)
						{
							$new_var[$type . $loops[$i] . '-color'] = trim($values) . ($important ? ' ' . $important : '');
						}
					break;

					case 'border-width':
					case 'border-color':
					case 'border-style':
					case 'margin':
					case 'padding':

						/*
						* Find if element !important is exists
						**/
						$important = $this->strpos_ary($values, array('!important', '! important'));

						if(isset($important))
						{
							$values = str_replace($important, "", $values);
						}

						$loops = array('-top', '-right', '-bottom', '-left');
						list($single_type, $style_type) = explode("-", $type);

						$single_type = $single_type ? $single_type : $type;
						$style_type = $style_type ? "-" . $style_type : '';

						$values = $this->remove_spaces($values, 'start-end');
						$explode = explode(" ", $values);

						switch(count($explode))
						{
							// if the count is 1 all values is the same
							case 1: $explode[1] = $explode[2] = $explode[3] = $explode[0]; break;
							// if the count is 2 the top and bottom is the same and the right and the left is the same
							case 2: $explode[2] = $explode[0]; $explode[3] = $explode[1]; break;
							// if the count is 3 the right and the left is the same
							case 3: $explode[3] = $explode[1]; break;
						}

						for($i = 0; $i < count($loops); ++$i)
						{
							$new_var[$single_type . $loops[$i] . $style_type] = $explode[$i] . ($important ? ' ' . $important : '');
						}

					break;

					case 'font':

						/*
						* Find if element !important is exists
						**/
						$important = $this->strpos_ary($values, array('!important', '! important'));

						if(isset($important))
						{
							$values = str_replace($important, "", $values);
						}

						/*
						* Check if background elements is inherit
						**/
						if(trim($values) == 'inherit')
						{
							$new_var[$type . '-size'] = $new_var[$type . '-weight'] = $new_var[$type . '-style'] = $new_var[$type . '-variant'] = $new_var[$type]['family'] = 'inherit' . ($important ? ' ' . $important : '');
							break;
						}

						/*
						* remove all font unknown values
						* fixing_needed!!!
						**/
						$values = str_replace(array('inherit', 'normal', 'caption', 'icon', 'menu', 'message-box', 'small-caption', 'status-bar'), array("", "", "", "", "", "", "", ""), $values);

						/*
						* Find if font size is exists
						**/
						$size_value = $this->strpos_ary($values, array('xx-small', 'x-small', 'small', 'medium', 'large', 'x-large', 'xx-large', 'smaller', 'larger'));

						if(!isset($size_value))
						{
							$combinations = array("/([0-9]+)px/", "/([0-9]+)em/", "/([0-9]+)%/");

							for($i = 0; $i < count($combinations); ++$i)
							{
								$size_match = array();

								preg_match($combinations[$i], $values, $size_match);

								if($size_match[0])
								{
									$size_value = $size_match[0];
									break;
								}
							}
						}

						if(isset($size_value))
						{
							$values = str_replace($size_value, "", $values);
							$new_var[$type . '-size'] = $size_value . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if font weight is exists
						**/
						$style_weight = $this->strpos_ary($values, array('bold', 'bolder', 'lighter', '100', '200', '300', '400', '500', '600', '700', '800', '900'));

						if(isset($style_weight))
						{
							$values = str_replace($style_weight, "", $values);
							$new_var[$type . '-weight'] = $style_weight . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if font style is exists
						**/
						$style_value = $this->strpos_ary($values, array('italic', 'oblique'));

						if(isset($style_value))
						{
							$values = str_replace($style_value, "", $values);
							$new_var[$type . '-style'] = $style_value . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if font variant is exists
						**/
						$style_variant = $this->strpos_ary($values, array('small-caps'));

						if(isset($style_variant))
						{
							$values = str_replace($style_variant, "", $values);
							$new_var[$type . '-variant'] = $style_variant . ($important ? ' ' . $important : '');
							if(trim($values) == '') break;
						}

						/*
						* Find if font family is exists
						* if somting is left in the values var it must be the font family
						**/
						$new_var[$type]['family'] = trim($values) . ($important ? ' ' . $important : '');
					break;
				}
			}
		}

		$new_vras = array();

		if(sizeof($new_var))
		{
			foreach($new_var as $key => $value)
			{
				$new_vras[] = "{$key}: {$value};";
			}
		}

		return $new_vras;
	}

	function strpos_ary($haystack, $needle)
	{
		for($i = 0; $i < count($needle); ++$i)
		{
			if(strpos($haystack, $needle[$i]) !== false)
			{
				return $needle[$i];
			}
		}

		return null;
	}

	function theme_template($based = 'prosilver')
	{
		global $phpbb_root_path, $phpEx;

		$tamplate = array();

		$file = $phpbb_root_path . "ate_files/cssmaps/" . $based . "." . $phpEx;

		if(file_exists($file) && in_array($based, $this->styles))
		{
			include_once($file);
		}

		return $template;
	}

	function insert_template($ate_id = 0, $based = 'prosilver')
	{
		global $db, $config;

		if(!in_array($based, $this->styles) || $ate_id <= 0)
		{
			return;
		}

		$sql = "SELECT ate_id
			FROM " . STYLES_ATE_THEME_TABLE . "
			WHERE ate_id = " . intval($ate_id) . "
			LIMIT 1";
		$result = $db->sql_query($sql);
		$elements_data = $db->sql_fetchrow($result);

		if($elements_data['ate_id'] <= 0)
		{
			return;
		}

		$template = array();
		$template = $this->theme_template($based);

		if($this->css_content && $config['ate_tpluse'])
		{
			// get selected style css map by the based tempalte elements!
			$template = $this->css_map($template);
		}

		$this->insert_data($ate_id, $template);
	}

	function css_map($based_template = null)
	{
		if(!$this->css_content)
		{
			return $based_template;
		}

		for($i = 0; $i < count($based_template); ++$i)
		{
			if(!trim($based_template[$i]['element_elements']))
			{
				continue;
			}

			$replacements_ary = array();

			if(trim($based_template[$i]['element_replacements']))
			{
				$replacements = explode(">", $based_template[$i]['element_replacements']);

				for($a = 0; $a < count($replacements); ++$a)
				{
					list($key, $value) = explode("|", $replacements[$a]);

					if(trim($value) != '')
					{
						$replacements_ary[$key] = $value;
					}
				}
			}

			$based_template[$i]['element_replacements'] = '';
			$elements = explode(">", $based_template[$i]['element_elements']);

			if(sizeof($elements))
			{
				$manage_values = array();

				foreach($elements as $element)
				{
					$data = $this->match_values($element, $this->css_content);

					/* 
					* if there is multiple matches with multiple duplicate properties 
					* im using the last match i found to replace the the last duplicate property
					**/
					for($a = 0; $a < count($data['matches']); ++$a)
					{
						$manage_values = array_merge($manage_values, $this->manage_values($data['matches'][$a][$data['block_num']], $replacements_ary, true));
					}
				}

				if(sizeof($manage_values))
				{
					$replacements_ary = array();

					foreach($manage_values as $key => $value)
					{
						$replacements_ary[] = "{$key}|{$value}";
					}

					$based_template[$i]['element_replacements'] = implode(">", $replacements_ary);
				}
			}
		}

		return $based_template;
	}

	function insert_data($ate_id, $data)
	{
		global $db;

		if($ate_id <= 0)
		{
			return false;
		}

		for($i = 0; $i < count($data); ++$i)
		{
			$sql_ary = array_merge($data[$i], array(
				'ate_id' 	=> $ate_id, 
			));

			$sql = 'INSERT INTO ' . STYLES_ATE_ELEMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}

		return true;
	}

	function delete_data($ate_id)
	{
		global $db;

		if($ate_id <= 0)
		{
			return;
		}

		$sql = "DELETE
			FROM " . STYLES_ATE_ELEMENTS_TABLE . "
			WHERE ate_id = '{$ate_id}'";
		$db->sql_query($sql);
	}

	function insert_custom_elements($ate_id = 0, $element_name, $element_code, $element_elements, $element_replacements)
	{
		global $db;

		if($ate_id <= 0 || trim($element_name) == '' || trim($element_elements) == '' || trim($element_replacements) == '' || trim($element_code) == '')
		{
			return false;
		}

		$sql = 'INSERT INTO ' . STYLES_ATE_ELEMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', array(
			'ate_id'		=> $ate_id,
			'element_code'		=> $element_code,
			'element_name'		=> $element_name,
			'element_section'	=> 'CUSTOM',
			'element_elements'	=> $element_elements,
			'element_replacements'	=> $element_replacements,
		));
		$db->sql_query($sql);

		return true;
	}

	function delete_element($element_code = '', $ate_id = 0, $element_id = 0)
	{
		global $db;

		if((!$element_code && !$element_id) || $ate_id <= 0)
		{
			return;
		}

		$sql = "DELETE
			FROM " . STYLES_ATE_ELEMENTS_TABLE . "
			WHERE ate_id = '{$ate_id}'
			" . ($element_code ? "AND element_code = '" . strtoupper($element_code) . "'" : '') . "
			" . ($element_id ? "AND element_id = '{$element_id}'" : '');
		$db->sql_query($sql);
	}

	function delete_theme($theme_id)
	{
		global $db;

		$sql = "SELECT ate_id 
			FROM " . STYLES_ATE_THEME_TABLE . "
			WHERE theme_id = '{$theme_id}'";
		$result = $db->sql_query($sql);
		$ate_data = $db->sql_fetchrow($result);

		if($ate_data)
		{
			$sql = "DELETE 
				FROM " . STYLES_ATE_THEME_TABLE . "
				WHERE ate_id = '{$ate_data['ate_id']}'";
			$db->sql_query($sql);

			$sql = "DELETE 
				FROM " . STYLES_ATE_ELEMENTS_TABLE . "
				WHERE ate_id = '{$ate_data['ate_id']}'";
			$db->sql_query($sql);

			return true;
		}

		return false;
	}

	function reset_elements($theme_id)
	{
		global $db;

		$sql = "SELECT at.ate_id, t.theme_based
			FROM " . STYLES_ATE_THEME_TABLE . " at, " . STYLES_THEME_TABLE . " t
			WHERE t.theme_id = '{$theme_id}'
			AND t.theme_id = at.theme_id";
		$result = $db->sql_query($sql);
		$ate_data = $db->sql_fetchrow($result);

		if($ate_data['ate_id'] > 0 && in_array($ate_data['theme_based'], $this->styles))
		{
			$this->delete_data($ate_data['ate_id']);
			$this->insert_template($ate_data['ate_id'], $ate_data['theme_based']);

			return true;
		}

		return false;
	}

	function create_array($ate_id = 0)
	{
		global $db;

		$output = array();

		if($ate_id <= 0)
		{
			return $output;
		}

		$sql = "SELECT element_elements, element_replacements, element_section
			FROM " . STYLES_ATE_ELEMENTS_TABLE . "
			WHERE ate_id = '{$ate_id}'";
		$result = $db->sql_query($sql);

		while($data = $db->sql_fetchrow($result))
		{
			if(trim($data['element_replacements']) == '' || trim($data['element_elements']) == '')
			{
				continue;
			}

			$replacements = explode(">", $data['element_replacements']);
			$replacements_ary = array();

			for($i = 0; $i < count($replacements); ++$i)
			{
				list($key, $value) = explode("|", $replacements[$i]);

				if(trim($value) != '')
				{
					$replacements_ary[$key] = $value;
				}
			}

			$output[] = array(
				'elements' 	=> explode(">", $data['element_elements']),
				'replacements' 	=> $replacements_ary,
				'section'	=> $data['element_section'],
			);
		}

		return $output;
	}

	function check_cfg($mode, $stylename, $based = '', $install = false)
	{
		global $phpbb_root_path;

		$output = array('exists' => false, 'data' => '');

		$subpath = ($mode != 'style') ? "$mode/" : '';
		$file = "{$phpbb_root_path}styles/$stylename/$subpath$mode.cfg";

		if(file_exists($file) && !is_dir($file))
		{
			if ($cfg = file($file))
			{
				$items = parse_cfg_file('', $cfg);

				$output['exists'] = isset($items['based']) ? true : false;
				$output['data'] = $items['based'];
				$output['allowed'] = in_array($items['based'], $this->styles) ? true : false;

				if($install && !$output['allowed'])
				{
					$this->install_cfg($stylename, $based);
				}
			}
		}

		return $output;
	}

	function install_cfg($stylename, $based = '')
	{
		global $phpbb_root_path;

		$dirs = array('style', 'theme', 'imageset', 'template');

		if(!in_array($based, $this->styles))
		{
			$count_files = array();

			$dp = @opendir("{$phpbb_root_path}styles/$stylename/theme");

			if ($dp)
			{
				while (($file = readdir($dp)) !== false)
				{
					if (is_dir("{$phpbb_root_path}styles/$stylename/theme/" . $file) || $file[0] == '.')
					{
						continue;
					}

					$count_files[] = $file;
				}
				closedir($dp);
			}

			$based = (count($count_files) > 3) ? 'prosilver' : 'subsilver2';
		}

		for($i = 0; $i < count($dirs); ++$i)
		{
			$this->edit_cfg($dirs[$i], $based, $stylename, false);
		}
	}

	function edit_cfg($mode, $based, $path, $force = true)
	{
		global $phpbb_root_path;

		$file_name = (($mode != 'style') ? $mode . "/" : '') . strtolower($mode) . ".cfg";
		$cfg_file = "{$phpbb_root_path}styles/{$path}/" . $file_name;

		if(!file_exists($cfg_file))
		{
			return false;
		}


		$check_cfg = $this->check_cfg($mode, $path);
		$cfg_content = file_get_contents($cfg_file);
		$write_file = false;

		if(!$check_cfg['exists'])
		{
			preg_match("/version \= ([A-Za-z0-9\._]+)/", $cfg_content, $matches);

			if(!isset($matches[0]))
			{
				return false;
			}

			$cfg_content = str_replace($matches[0], "{$matches[0]}\r\nbased = {$based}", $cfg_content);
			$write_file = true;
		}
		elseif($check_cfg['exists'] && (!$check_cfg['allowed'] || ($check_cfg['allowed'] && $check_cfg['data'] != $based && $force)))
		{
			$cfg_content = str_replace("/based \= {$check_cfg['data']}/", "based = {$based}", $cfg_content);
			$write_file = true;
		}

		if($write_file)
		{
			if($fh = fopen($cfg_file, "w+"))
			{
				fwrite($fh, $cfg_content);
				fclose($fh);
			}
			else
			{
				return false;
			}
		}

		return true;
	}

	function tags_options($selected_option = '', $ary = false)
	{
		global $user;

		$options = $ary ? array() : '';

		foreach(array_keys($this->tags) as $tag)
		{
			if($ary)
			{
				$options[$tag] = array($user->lang[str_replace("-", "_", $tag)], $user->lang[str_replace("-", "_", $tag) . '_EXPLAIN']);
			}
			else
			{
				$selected = $tag == $selected_option ? " selected='selected'" : '';
				$options .= "<option value='{$tag}' title='" . addslashes($user->lang[str_replace("-", "_", $tag) . '_EXPLAIN']) . "'{$selected}>{$user->lang[str_replace("-", "_", $tag)]}</option>";
			}
		}

		return $options;
	}

	function rgb_to_hex($data)
	{
		$r = intval($data[0]); 
		$g = intval($data[1]);
		$b = intval($data[2]);

		$r = dechex($r < 0 ? 0 : ($r > 255 ? 255 : $r));
		$g = dechex($g < 0 ? 0 : ($g > 255 ? 255 : $g));
		$b = dechex($b < 0 ? 0 : ($b > 255 ? 255 : $b));

		$value = (strlen($r) < 2 ? '0' : '') . $r;
		$value .= (strlen($g) < 2 ? '0' : '') . $g;
		$value .= (strlen($b) < 2 ? '0' : '') . $b;
		$value = "#" . strtoupper($value);

		return $value;
	}

	function handle_values($tag, $value, $reverse = false, $s_error = false)
	{
		if(!in_array($tag, array_keys($this->tags)))
		{
			return $value;
		}

		switch($tag)
		{
			case 'BG-IMAGE':

				$value = trim($value);

				if(strtolower($value) != 'none')
				{
					$replacements = array(
						'{'	=> "*--start--", 
						'}'	=> "--end--*",
					);

					if($reverse)
					{
						$value = str_replace(array_merge(array_keys($replacements), array("'", '"', 'url(', ')')), array_merge(array_values($replacements), array("", "", "", "")), $value);
						$value = 'url("' . $value . '")';
					}
					else
					{
						preg_match("/url\(\'*\"*(.*?)\'*\"*\)/", $value, $match);
						$value = str_replace(array_values($replacements), array_keys($replacements), $match[1]);
					}
				}

			break;

			case 'COLOR':
			case 'BG-COLOR':
			case 'BORDER-LEFT-COLOR':
			case 'BORDER-BOTTOM-COLOR':
			case 'BORDER-RIGHT-COLOR':
			case 'BORDER-TOP-COLOR':

				if($s_error)
				{
					break;
				}

				// remove the # char and any space for the checking
				$value = trim(str_replace("#", "", $value));

				if(strpos(strtolower($value), "rgb") !== false || strpos($value, ",") !== false)
				{
					if(strpos(strtolower($value), "rgb") !== false)
					{
						preg_match("/rgb\((.*?)\)/", strtolower($value), $match);
					}
					else
					{
						$match[1] = $value;
					}

					$rgb_values = explode(",", $match[1]);

					if(sizeof($rgb_values) == 3)
					{
						$value = $this->rgb_to_hex($rgb_values);
					}
				}
				elseif(in_array(strlen($value), array(3, 6)))
				{
					$hex_is_valid = true;
					$value_ary = str_split($value);

					for($i = 0; $i < count($value_ary); ++$i)
					{
						if(!in_array(strtoupper($value_ary[$i]), array('A', 'B', 'C', 'D', 'E', 'F', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9')))
						{
							$hex_is_valid = false;
							break;
						}
					}

					if($hex_is_valid)
					{
						// if none invalid hex chars was found, the value is hex color
						$value = "#" . strtoupper($value);
					}
				}

			break;

			case 'BG-REPEAT':

				if(!in_array($value, array('repeat', 'no-repeat', 'repeat-x', 'repeat-y', 'inherit')))
				{
					$value = 'repeat';
				}

			break;

			case 'BG-ATTACHMENT':

				if(!in_array($value, array('scroll', 'fixed', 'inherit')))
				{
					$value = 'scroll';
				}

			break;
		}

		return $value;
	}

	function install($based, $theme_id = 0, $mode = '', $path = '')
	{
		global $db;

		if($mode && $path)
		{
			$this->edit_cfg($mode, $based, $path);
		}

		if($theme_id > 0)
		{
			$sql = "INSERT INTO " . STYLES_ATE_THEME_TABLE . ' ' . $db->sql_build_array('INSERT', array(
				'theme_data'	=> '',
				'theme_id'	=> $theme_id,
			));
			$db->sql_query($sql);

			$ate_id = $db->sql_nextid();
 
			$sql = "SELECT theme_data
				FROM " . STYLES_THEME_TABLE . "
				WHERE theme_id = '{$theme_id}'";
			$result = $db->sql_query($sql);
			$theme_info = $db->sql_fetchrow($result);

			$this->load_css($theme_info['theme_data']);

			// create css map based on the theme base
			$this->insert_template($ate_id, $based);

			return $ate_id;
		}

		return true;
	}

	function download($filename, $filedata)
	{
		header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
		header('Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT');
		header('Cache-Control: no-store, no-cache, must-revalidate');
		header('Cache-Control: post-check=0, pre-check=0', false);
		header('Content-Type: binary');
		header('Pragma: no-cache');
		header("Content-Disposition: attachment; filename={$filename}");
		echo $filedata;
		exit;
	}

	function backup($ate_id, $theme_based = 'peosilver', $backup_type, $mode = 'store')
	{
		global $db, $phpbb_root_path;

		$backup_type = strtolower($backup_type);
		if(!in_array($backup_type, array('sql', 'xml')) || !in_array($theme_based, $this->styles))
		{
			return false;
		}

		$mode = in_array($mode, array('store', 'download', 'store_and_download')) ? $mode : 'store';
		$backup_data = '';

		switch($backup_type)
		{
			case 'xml': $backup_data = $this->xml_dump($ate_id); break;
			case 'sql': $backup_data = $this->sql_dump($ate_id); break;
		}

		if(!$backup_data)
		{
			return false;
		}

		$filename = $this->create_filename("ateStyleBackup_" . time() . "_{$ate_id}_{$theme_based}", $backup_type);

		$backup_type = $backup_type == 'sql' ? 'backup' : $backup_type;

		if(in_array($mode, array('store', 'store_and_download')))
		{
			if($f = @fopen(realpath($phpbb_root_path . $this->paths[$backup_type]) . '/' . $filename, "w+"))
			{
				@fwrite($f, $backup_data);
				@fclose($f);

				$this->insert_file($filename, $backup_type, 'ATE theme backup on ' . $backup_type . ' file');

				if($mode == 'store')
				{
					return true;
				}
			}
		}

		if(in_array($mode, array('download', 'store_and_download')))
		{
			$this->download($filename, $backup_data);
		}

		return false;
	}

	function restore($ate_id, $file_id, $restore_type)
	{
		global $db, $phpbb_root_path;

		if($ate_id <= 0)
		{
			return false;
		}

		$sql = "SELECT file_name, file_type
			FROM " . STYLES_ATE_FILES_TABLE . "
			WHERE file_id = '{$file_id}'";
		$result = $db->sql_query($sql);
		$file_data = $db->sql_fetchrow($result);

		if($file_data)
		{
			$this->delete_data($ate_id);

			switch($restore_type)
			{
				case 'xml':
					if($this->insert_data($ate_id, $this->extract_xml($phpbb_root_path . $this->paths['xml'] . $file_data['file_name'])))
					{
						return true;
					}
				break;

				case 'sql':
					$sql = file_get_contents($phpbb_root_path . $this->paths['backup'] . $file_data['file_name']);

					if($sql) 
					{
						if($db->sql_query($sql))
						{
							return true;
						}
					}
				break;
			}
		}

		return false;
	}

	function sql_dump($ate_id) 
	{
		global $config, $db;

		$lnbr = "\r\n";

		$query = "-- Advanced Theme Editor v{$config['ate_version']}" . $lnbr;
		$query .= "--" . $lnbr;
		$query .= "-- Backup ATE ID " . $ate_id . $lnbr;
		$query .= "-- Backup Time: " . date("d F, Y on H:i", time()) . $lnbr;
		$query .= "--" . $lnbr . $lnbr;
		$query .= "SET SQL_MODE='NO_AUTO_VALUE_ON_ZERO';" . $lnbr . $lnbr;
		$query .= "-- --------------------------------------------------------" . $lnbr . $lnbr;

		$sql = "SELECT *
			FROM " . STYLES_ATE_ELEMENTS_TABLE . "
			WHERE ate_id = '{$ate_id}'";
		$result = $db->sql_query($sql);

		$first = 1;
		while ($row = $db->sql_fetchrow($result))
		{
			$data = array();

			if ($first)
			{
				$query .= 'INSERT INTO `' . STYLES_ATE_ELEMENTS_TABLE . '` (';

				$i = 0;
				while (list($key, $value) = @each($row)) 
				{ 
					$i++;

					if($i > 1)
					{
						$data['keys'][] = $key; 
						$data['values'][] = addslashes($value); 
					}
				}

				$query .= join($data['keys'], ', ') . ') VALUES ' . $lnbr;

				$first = 0;
			}
			else 
			{
				$query .= ','.$lnbr;

				$i = 0;
				while (list($key, $value) = @each($row)) 
				{ 
					$i++;

					if($i > 1) $data['values'][] = addslashes($value); 
				}
			}

			$query .= '(\'' . join($data['values'], '\', \'') . '\')';
		}

		if ( $first == 0 ) $query .= ';'.$lnbr; 

		$query .= str_repeat($lnbr, 2);

		return $query;
	}

	function xml_dump($ate_id)
	{
		global $db, $phpbb_root_path;

		$sql = "SELECT *
			FROM " . STYLES_ATE_ELEMENTS_TABLE . "
			WHERE ate_id = '{$ate_id}'";
		$result = $db->sql_query($sql);

		$xml_data = "<?xml version='1.0' encoding='UTF-8'?>\r\n<ate_style>\r\n";

		while($elements = $db->sql_fetchrow($result))
		{
			$elements_rows = '';
			$elements_explode = explode(">", $elements['element_elements']);

			if(sizeof($elements_explode))
			{
				foreach($elements_explode as $row)
				{
					$elements_rows .= "			<element>{$row}</element>\r\n";
				}
			}

			$replacements_rows = '';
			$replacements_explode = explode(">", $elements['element_replacements']);

			if(sizeof($replacements_explode))
			{
				foreach($replacements_explode as $row)
				{
					list($property, $value) = explode("|", $row);
					$replacements_rows .= "			<replacement>\r\n";
					$replacements_rows .= "				<property>{$property}</property>\r\n";
					$replacements_rows .= "				<value>{$value}</value>\r\n";
					$replacements_rows .= "			</replacement>\r\n";
				}
			}

			$xml_data .= "	<row>\r\n";
			$xml_data .= "		<name>{$elements['element_name']}</name>\r\n";
			$xml_data .= "		<code>{$elements['element_code']}</code>\r\n";
			$xml_data .= "		<section>{$elements['element_group']}</section>\r\n";
			$xml_data .= "		<elements>\r\n";
			$xml_data .= $elements_rows;
			$xml_data .= "		</elements>\r\n";
			$xml_data .= "		<replacements>\r\n";
			$xml_data .= $replacements_rows;
			$xml_data .= "		</replacements>\r\n";
			$xml_data .= "	</row>\r\n";


		}
		$db->sql_freeresult($result);

		$xml_data .= "</ate_style>";

		return $xml_data;
	}

	function extract_xml($file_location)
	{
		global $user;

		if(!file_exists($file_location))
		{
			return;
		}

		if(version_compare(PHP_VERSION, '5.0.0', '<'))
		{
			trigger_error($user->lang['ATE_STYLE_RESTORE_PHP_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$xml = simplexml_load_file($file_location);

		$element = array();

		if(sizeof($xml->row))
		{
			$i = 0;
			foreach($xml->row as $data)
			{
				$element[$i]['element_name'] = (string) $data->name;
				$element[$i]['element_code'] = (string) $data->code;
				$element[$i]['element_section'] = (string) $data->section;

				$elements_ary = $replacements_ary = array();

				if(sizeof($data->elements->element))
				{
					foreach($data->elements->element as $elements)
					{
						$elements_ary[] = $elements;
					}
				}

				if(sizeof($data->replacements->replacement))
				{
					foreach($data->replacements->replacement as $replacements)
					{
						$replacements_ary[] = $replacements->property . "|" . $replacements->value;
					}
				}

				$element[$i]['element_elements'] = implode(">", $elements_ary);
				$element[$i]['element_replacements'] = implode(">", $replacements_ary);

				$i++;
			}
		}

		return $element;
	}

	function insert_file($file_name, $file_type, $file_desc = '')
	{
		global $db, $phpbb_root_path;

		if(!in_array($file_type, array('uploaded', 'backup', 'xml')))
		{
			return;
		}

		$sizes = array(" Bytes", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
		$data['file_size'] = (round(filesize($phpbb_root_path . $this->paths[$file_type])/pow(1024, ($i = floor(log(filesize($phpbb_root_path . $this->paths[$file_type]), 1024)))), 2) . $sizes[$i]);
		$data['file_name'] = $file_name; 
		$data['file_type'] = $file_type; 
		$data['file_desc'] = $file_desc;

		$sql = "INSERT INTO " . STYLES_ATE_FILES_TABLE . ' ' . $db->sql_build_array('INSERT', array(
			'file_name'		=> $data['file_name'],
			'file_desc'		=> $data['file_desc'],
			'file_size'		=> $data['file_size'],
			'file_type'		=> $data['file_type'],
			'file_time'		=> time(),
		));
		$db->sql_query($sql);

		$data['file_id'] = $db->sql_nextid();

		return $data;
	}

	function file_upload($file, $type, $file_desc, $ajax)
	{
		global $phpbb_root_path;

		$this->uploading = true;

		$file_realname = basename($file['name']);
		$file_ext = substr($file_realname, strrpos($file_realname, '.'));

		for($i = 0; $i < 100; ++$i)
		{
			$file_name = $this->create_filename("ateCustomFile_" . time(), $file_ext);
			$file_target_path = $phpbb_root_path . $this->paths[$type] . $file_name; 

			if(!file_exists($file_target_path) && !is_dir($file_target_path))
			{
				break;
			}
		}

		if(file_exists($file_target_path) || is_dir($file_target_path))
		{
			$this->ajax_message($ajax, "{ 'msg' : 'ERROR_FILE_EXISTS' }");
			return false;
		}

		if(move_uploaded_file($file['tmp_name'], $file_target_path))
		{
			$data = $this->insert_file($file_name, $type, $file_desc);
			$this->ajax_message($ajax, "{ 'msg' : 'UPLOADED', 'file_name' : '{$data['file_name']}', 'file_desc' : '{$data['file_desc']}', 'file_size' : '{$data['file_size']}', 'file_id' : '{$data['file_id']}', 'file_type' : '{$data['file_type']}' }");
			return true;
		}

		$this->ajax_message($ajax, "{ 'msg' : 'ERROR_FILE_NOT_MOVED' }");
		return false;
	}

	function create_filename($file_var, $file_ext = '')
	{
		$file_name = $file_var . "_" . unique_id() . ((substr($file_ext, 0, 1) != '.' && $file_ext != '') ? '.' : '') . $file_ext;

		return $file_name;
	}

	function file_delete($file_id, $file_type = '', $ajax)
	{
		global $db, $phpbb_root_path;

		$this->uploading = true;

		if(!in_array($file_type, array('uploaded', 'backup', 'xml')))
		{
			$this->ajax_message($ajax, "<!-- ajax: ERROR_NO_FILE_TYPE -->");
			return false;
		}

		$sql = "SELECT file_name
			FROM " . STYLES_ATE_FILES_TABLE . "
			WHERE file_id = '" . intval($file_id) . "'";
		$result = $db->sql_query($sql);
		$file_details = $db->sql_fetchrow($result);

		if($file_details['file_name'])
		{
			$file = $phpbb_root_path . $this->paths[$file_type] . $file_details['file_name'];

			if(file_exists($file) && !is_dir($file))
			{
				unlink($file);
			}

			$sql = "DELETE 
				FROM " . STYLES_ATE_FILES_TABLE . "
				WHERE file_id = '" . intval($file_id) . "'";
			$db->sql_query($sql);

			$this->ajax_message($ajax, "<!-- ajax: DELETED -->");
			return true;
		}

		$this->ajax_message($ajax, "<!-- ajax: ERROR_UNKNOWN -->");
		return false;
	}

	function check_installation($theme_id, $theme_based)
	{
		global $db;

		$sql = "SELECT *
			FROM " . STYLES_ATE_THEME_TABLE . "
			WHERE theme_id = '{$theme_id}'";
		$result = $db->sql_query($sql);
		$ate_theme_info = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if (intval($ate_theme_info['ate_id']) <= 0)
		{
			$ate_theme_info['ate_id'] = $this->install($theme_based, $theme_id);
		}

		$this->ate_id = $ate_theme_info['ate_id'];

		return $ate_theme_info;
	}

	function change_based($based, $theme_id)
	{
		global $db;

		if(!in_array($based, $this->styles))
		{
			return;
		}

		$sql = "SELECT at.ate_id, t.theme_based
			FROM " . STYLES_ATE_THEME_TABLE . " at, " . STYLES_THEME_TABLE . " t
			WHERE at.theme_id = '{$theme_id}'
			AND at.theme_id = t.theme_id";
		$result = $db->sql_query($sql);
		$ate_theme_info = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if($ate_theme_info['theme_based'] != $based)
		{
			$this->delete_theme($theme_id);
		}
	}

	function javascript($type = 'tags', $theme_id = 0)
	{
		global $phpbb_root_path, $user, $db;

		switch($type)
		{
			case 'tags':
				$js_tags = $this->tags_options('', true);
				$output = array();
		
				if(sizeof($js_tags))
				{
					foreach($js_tags as $tag_code => $tag_lang)
					{
						$output[] = "['{$tag_code}', '{$tag_lang[0]}', '" . addslashes($tag_lang[1]) . "']";
					}
				}

				return implode(",", $output);
			break;

			case 'replace':
			case 'search':

				$output = array();

				$sql = 'SELECT c.theme_path, i.imageset_path, t.template_path
					FROM ' . STYLES_TABLE . ' s, ' . STYLES_TEMPLATE_TABLE . ' t, ' . STYLES_THEME_TABLE . ' c, ' . STYLES_IMAGESET_TABLE . ' i
					WHERE s.theme_id = ' . $theme_id . '
					AND t.template_id = s.template_id
					AND c.theme_id = s.theme_id
					AND i.imageset_id = s.imageset_id';
				$result = $db->sql_query($sql, 300);
				$theme = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				/*
				* the theme is not attached to a style
				* get the theme path
				**/
				if(!$theme)
				{
					$sql = 'SELECT theme_path
						FROM ' . STYLES_THEME_TABLE . '
						WHERE theme_id = ' . $theme_id;
					$result = $db->sql_query($sql, 300);
					$theme = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);

					$theme['template_path'] = $theme['imageset_path'] = $theme['theme_path'];
				}

				$replace = array(
					'{T_THEME_PATH}'		=> "{$phpbb_root_path}styles/" . $theme['theme_path'] . '/theme',
					'{T_TEMPLATE_PATH}'		=> "{$phpbb_root_path}styles/" . $theme['template_path'] . '/template',
					'{T_IMAGESET_PATH}'		=> "{$phpbb_root_path}styles/" . $theme['imageset_path'] . '/imageset',
					'{T_IMAGESET_LANG_PATH}'	=> "{$phpbb_root_path}styles/" . $theme['imageset_path'] . '/imageset/' . $user->data['user_lang'],
					'{T_ATE_PATH}'			=> "{$phpbb_root_path}ate_files",
				);

				$output = ($type == 'search') ? array_keys($replace) : array_values($replace);

				return sizeof($output) ? "'" . implode("','", $output)  . "'" : '';
			break;

			case 'properties':

				$output = array();

				if(sizeof($user->lang['property_values']))
				{
					foreach($user->lang['property_values'] as $key => $lang)
					{
						$output[] = "ateLang['" . str_replace("_", "-", $key) . "'] = '{$lang}';";
					}
				}

				return implode("\r\n", $output);
			break;
		}
	}

	function ajax_message($active, $message)
	{
		if($active)
		{
			echo $message;
			exit;
		}

		return;
	}
}

?>