<?php
/**
 *
 * @author idanbe (Idan Ben-Ezra) idanbe@habeitarim.co.il
 * @version $Id$
 * @copyright (c) 2010 idanbe
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */

/**
 * @ignore
 */
define('UMIL_AUTO', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'Advanced Theme Editor';

/*
* The name of the config variable which will hold the currently installed version
* UMIL will handle checking, setting, and updating the version itself.
*/
$version_config_name = 'ate_version';


// The language file which will be included when installing
$language_file = 'mods/ate';


/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
//$logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'0.2.0' => array(

		'table_add' => array(
			array(phpbb_styles_ate_elements, array(
				'COLUMNS' => array(
					'element_id' => array('UINT', null, 'auto_increment'),
					'ate_id' => array('UINT', '0'),
					'element_name' => array('VCHAR', ''),
					'element_code' => array('VCHAR', ''),
					'element_section' => array('VCHAR', ''),
					'element_elements' => array('TEXT', ''),
					'element_replacements' => array('TEXT', ''),
				),

				'PRIMARY_KEY'	=> array('element_id'),
			)),

			array(phpbb_styles_ate_theme, array(
				'COLUMNS' => array(
					'ate_id' => array('UINT', null, 'auto_increment'),
					'theme_id' => array('UINT', '0'),
					'theme_data' => array('MTEXT', ''),
				),

				'PRIMARY_KEY'	=> array('ate_id'),
			)),

			array(phpbb_styles_ate_files, array(
				'COLUMNS' => array(
					'file_id' => array('UINT', null, 'auto_increment'),
					'file_name' => array('VCHAR', ''),
					'file_size' => array('VCHAR', ''),
					'file_desc' => array('VCHAR', ''),
					'file_type' => array('VCHAR', 'uploaded'),
					'file_time' => array('UINT:11', '0'),
				),

				'PRIMARY_KEY'	=> array('file_id'),
			)),

			array(phpbb_styles_ate_sections, array(
				'COLUMNS' => array(
					'section_id' => array('UINT', null, 'auto_increment'),
					'section_name' => array('VCHAR', ''),
					'section_order' => array('UINT:11', '0'),
				),

				'PRIMARY_KEY'	=> array('section_id'),
			)),

		),

		'table_column_add' => array(
			array('phpbb_styles_theme', 'theme_based', array('VCHAR', '')),
			array('phpbb_styles_theme', 'ate_active', array('TINT:1', '0')),
			array('phpbb_styles_template', 'template_based', array('VCHAR', '')),
			array('phpbb_styles_imageset', 'imageset_based', array('VCHAR', '')),
			array('phpbb_styles', 'style_based', array('VCHAR', '')),
		),

		'config_add' => array(
			array('ate_tpluse', '1', 0),
			array('ate_active', '0', 0),
			array('ate_installed', '1', 0),
		),

		'module_add' => array(
			array('acp', 'ACP_CAT_STYLES', 'ACP_ATE'),
			array('acp', 'ACP_ATE',
				array('module_basename'   => 'ate'),
			),
		),

		'table_row_insert' => array(
			array(phpbb_styles_ate_sections, array(
				array('section_name' => 'MAIN', 'section_order' => 1), 
				array('section_name' => 'CORNERS', 'section_order' => 2), 
				array('section_name' => 'POLLS', 'section_order' => 3), 
				array('section_name' => 'ICONS', 'section_order' => 4), 
				array('section_name' => 'CUSTOM', 'section_order' => 5), 
				array('section_name' => 'UPLOADED_FILES', 'section_order' => 6),
			)),
		),
	),
);

// Include the UMIL Auto file, it handles the rest
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>